1000 REMark  =========================================================
1005 REMark |   DJTOOLKIT DEMO ROUTINES - BY DILWYN JONES, FEB 1993   |
1010 REMark  =========================================================
1015 :
1020 REMark  =========================================================
1025 REMark | WARNING WARNING WARNING WARNING WARNING WARNING WARNING |
1030 REMark  =========================================================
1035 REMark | Some of these routines have LOCal parameters. If the    |
1040 REMark | total number of LOCals plus parameters is more than 9   |
1045 REMark | some QLs (notably JS) will corrupt the basic program    |
1050 REMark | and possible the QDOS name table & list as well. For    |
1055 REMark | this reason, some LOCal statements have been REMarked   |
1060 REMark | out. Only unREMark these lines if you are compiling     |
1065 REMark | the procedures and will ONLY run the compiled version.  |
1070 REMark  =========================================================
1075 :
1080 REMark  =========================================================
1085 REMark | Various 'corrections' by Norman Dunbar, October 1993 !! |
1090 REMark  =========================================================
1095 :
1100 DEFine PROCedure CURSOR_ENABLE (channel)
1105   REMark check if a cursor enabling command is installed.
1110   REMark If not, use an undocumented command!
1115   IF CHECK('Q_CURSON') THEN 
1120     Q_CURSON #channel : REMark QLiberator
1125   ELSE 
1130     IF CHECK('CURSEN') THEN 
1135       CURSEN #channel : REMark Toolkit 2
1140     ELSE 
1145       PAN #channel,0,115 : REMark undocumented cursor on!
1150     END IF 
1155   END IF 
1160 END DEFine CURSOR_ENABLE
1165 :
1170 DEFine PROCedure CURSOR_DISABLE (channel)
1175   REMark check if a cursor disabling command is installed
1180   REMark if not use an undocumented command
1185   IF CHECK('Q_CURSOFF') THEN 
1190     Q_CURSOFF #channel : REMark QLiberator
1195   ELSE 
1200     IF CHECK('CURDIS') THEN 
1205       CURDIS #channel : REMark Toolkit 2
1210     ELSE 
1215       PAN #channel,0,116 : REMark undocumented cursor disable
1220     END IF 
1225   END IF 
1230 END DEFine CURSOR_DISABLE
1235 :
1240 DEFine PROCedure SLIDE_SHOW
1245   LOCal no_of_screens, base, sc$(1,42), a
1250   CLS : CLS #0
1255   INPUT'How many screens ? ';no_of_screens
1260   base = RESERVE_HEAP(32768*no_of_screens)
1265   IF base <= 0 THEN 
1270     BEEP 5000,50 : PRINT #0,ERROR_MESSAGE$(base) : RETurn 
1275   END IF 
1280   DIM sc$(no_of_screens,42)
1285   FOR a = 1 TO no_of_screens
1290     INPUT'Enter name of screen ';(a);':';sc$(a-1)
1295     LBYTES sc$(a-1)&'',base+(32768*(a-1))
1300   END FOR a
1305   CLS : CLS #0
1310   FOR a = 0 TO no_of_screens - 1
1315     MOVE_MEM base + (32768*a) TO SCREEN_BASE(#1),32768
1320     PAUSE 50 : REMark adjust for delay required between pictures
1325   END FOR a
1330   RELEASE_HEAP base
1335 END DEFine SLIDE_SHOW
1340 :
1345 DEFine PROCedure REFLECT_SCREEN
1350   LOCal line_width, from, dest, a
1355   line_width = DISPLAY_WIDTH_JM(#1)
1360   from = SCREEN_BASE(#1)
1365   dest = SCREEN_BASE(#1) + 32768 - line_width
1370   FOR a = 0 TO 127
1375     POKE_STRING dest,PEEK_STRING(from,line_width)
1380     from = from + line_width : dest = dest - line_width
1385   END FOR a
1390 END DEFine REFLECT_SCREEN
1395 :
1400 DEFine PROCedure ZOOM_IN
1405   LOCal line_width, from, dest, a, s$
1410   line_width = DISPLAY_WIDTH_JM (#1)
1415   from = SCREEN_BASE(#1) + 16384 - line_width
1420   dest = SCREEN_BASE(#1) + 32768 - (2*line_width)
1425   FOR a = 0 TO 127
1430     s$ = PEEK_STRING(from,line_width)
1435     POKE_STRING dest,s$&s$
1440     from = from - line_width : dest = dest - (2*line_width)
1445   END FOR a
1450 END DEFine ZOOM_IN
1455 :
1460 DEFine PROCedure SAVE_THE_SCREEN
1465   LOCal base
1470   base = RESERVE_HEAP (32768)
1475   MOVE_MEM SCREEN_BASE(#1) TO base,32768
1480   CLS #2 : CLS : CLS #0
1485   PRINT #0,'Press a key to restore screen.';
1490   CURSOR_ENABLE #0 : PAUSE : CURSOR_DISABLE #0
1495   MOVE_MEM base TO SCREEN_BASE(#1),32768
1500   RELEASE_HEAP base
1505   PRINT #0,
1510 END DEFine SAVE_THE_SCREEN
1515 :
1520 DEFine PROCedure RANDOM_ACCESS
1525   LOCal f$, a, b%, loop, no, look_at_file
1530   CLS : INPUT 'Enter a filename:';f$
1535   OPEN_NEW #3,f$
1540   PRINT 'Writing 100 random numbers to file.'
1545   FOR a = 1 TO 100
1550     b% = RND(0 TO 255)
1555     PUT_BYTE #3,b%
1560   END FOR a
1565   CLOSE #3
1570   REMark now open it again to read the information as required
1575   OPEN_IN #3,f$
1580   REPeat look_at_file
1585     REPeat loop
1590       CLS : PRINT 'Enter a number from 1 to 100'
1595       INPUT '(or 0 to quit):';no
1600       IF no < 0 OR no > 100 THEN 
1605         BEEP 5000,50 : PRINT 'Try again'
1610         PAUSE 100 : NEXT loop
1615       END IF 
1620       EXIT loop
1625     END REPeat loop
1630     IF no = 0 THEN CLOSE #3 : EXIT look_at_file
1635     PRINT'Number ';no;' was:';
1640     ABS_POSITION #3,no-1
1645     b% = GET_BYTE(#3)
1650     PRINT b%
1655     PAUSE 200
1660   END REPeat look_at_file
1665   CLOSE #3
1670   DELETE f$
1675 END DEFine RANDOM_ACCESS
1680 :
1685 DEFine PROCedure FILE_DETAILS (f$)
1690   LOCal type
1695   PRINT'FILENAME:';f$
1700   type = FILE_TYPE(f$)
1705   IF type = -7 THEN PRINT ERROR_MESSAGE$(type) : RETurn 
1710   PRINT 'File type = ';
1715   SELect ON type
1720     =0 : PRINT 'Data file'
1725     =1 : PRINT 'EXECable file, dataspace = ';FILE_DATASPACE(f$)
1730     =2 : PRINT 'Linker file'
1735     =255 : PRINT 'Directory'
1740   END SELect 
1745   PRINT 'File length = ';FILE_LENGTH(f$)
1750   PRINT 'File update date = ';DATE$(FILE_UPDATE(f$))
1755   PRINT 'File backup date = ';DATE$(FILE_BACKUP(f$))
1760 END DEFine FILE_DETAILS
1765 :
1770 DEFine PROCedure DRIVE_DETAILS
1775   LOCal devices$(20,42), no_of_devs, address, floppy, ramdisk, loop, a
1780   LOCal df$, t$
1785   no_of_devs = 0
1790   address = 0
1795   floppy = 0 : ramdisk = 0
1800   REPeat loop
1805     devices$(no_of_devs) = DEV_NAME(address)
1810     IF devices$(no_of_devs) == 'RAM' THEN ramdisk = 1
1815     IF devices$(no_of_devs) == 'FLP' THEN floppy = 1
1820     IF devices$(no_of_devs) <> '' : no_of_devs = no_of_devs + 1
1825     IF address = 0 THEN EXIT loop
1830   END REPeat loop
1835   CLS : CLS #0
1840   FOR a = 0 TO no_of_devs - 1
1845     PRINT a;':';devices$(a)
1850   END FOR a
1855   INPUT\'Select a device by entering its number:';dvn
1860   INPUT 'Enter drive number:';drn
1865   IF ramdisk = 1 THEN 
1870     df$ = 'RAM'&drn&'_'
1875   ELSE 
1880     IF floppy = 1 THEN 
1885       df$ = 'FLP'&drn&'_'
1890     ELSE 
1895       df$ = 'MDV'&drn&'_'
1900     END IF 
1905   END IF 
1910   OPEN_NEW #3,df$ & 'TMP_dir'
1915   DIR #3,devices$(dvn)&drn&'_'
1920   CLOSE #3
1925   OPEN_IN #3,df$ & 'TMP_dir'
1930   CLS #0 : PRINT #0,'Use CTRL F5 to pause list'
1935   CLS : PRINT 'MEDIUM NAME:';
1940   INPUT #3,t$ : PRINT t$
1945   PRINT'CAPACITY:'; : INPUT #3,t$ : PRINT t$
1950   REPeat loop
1955     IF EOF (#3) : EXIT loop
1960     INPUT #3,t$
1965     FILE_DETAILS devices$(dvn)&drn&'_'&t$
1970     PRINT : PAUSE 25
1975   END REPeat loop
1980   CLOSE #3 : DELETE df$ & 'TMP_dir'
1985   CLS #0
1990 END DEFine DRIVE_DETAILS
1995 :
2000 DEFine PROCedure SHOW_QUARTER_SCREENS
2005   REMark Finds files of length 32768 and displays them
2010   REMark    on screen 4 at a time (quarter of each)
2015   LOCal d$, t$, p$, k$(1), showing
2020   CLS : CLS #0
2025   INPUT'Enter drive name:';d$
2030   OPEN_NEW #3,d$&'TMP_dir' : DIR #3,d$ : CLOSE #3
2035   OPEN_IN #3,d$&'TMP_dir'
2040   INPUT #3,t$ : REMark read past medium name ...
2045   INPUT #3,t$ : REMark ... and capacity
2050   showing = 0
2055   WINDOW 512,256,0,0
2060   REPeat loop
2065     IF EOF(#3) : EXIT loop
2070     INPUT #3,t$
2075     IF t$ == 'TMP_dir' THEN NEXT loop : REMark don't show itself!
2080     IF FILE_TYPE(d$&t$) = 0 THEN 
2085       REMark it is a data file
2090       IF FILE_LENGTH(d$&t$) = 32768 THEN 
2095         REMark correct length for a QL screen
2100         OPEN_IN #4,d$&t$
2105         ABS_POSITION #4,8192*showing
2110         p$ = FETCH_BYTES_JM$(#4,8192)
2115         POKE_STRING SCREEN_BASE(#1) + 8192*showing,p$
2120         CLOSE #4
2125         REMark show filename
2130         AT 7*showing,10 : PRINT t$
2135         showing = showing + 1
2140         IF showing = 4 THEN 
2145           BEEP 200,10 : REMark pause after each screenful
2150           CURSOR_ENABLE #0 : k$ = INKEY$(-1) : CURSOR_DISABLE #0
2155           IF k$ = CHR$(27) THEN EXIT loop
2160           CLS : showing = 0
2165         END IF 
2170       END IF 
2175     END IF 
2180   END REPeat loop
2185   CLOSE #3 : DELETE d$ & 'TMP_dir' : PAUSE 100
2190   IF CHECK('WTV') THEN 
2195     WTV 4
2200   ELSE 
2205     WINDOW 448,200,32,16
2210     CLS : CLS #0
2215   END IF 
2220   PRINT #0,'PROGRAM FINISHED.'
2225 END DEFine SHOW_QUARTER_SCREENS
2230 :
2235 DEFine PROCedure QUARTER_SCREENS2
2240   REMark Alternative version of above, shows 4 corners of screens
2245   LOCal d$, t$, p$, k$(1), showing, dw, sa, ap, a
2250   REMark LOCal sm2: REMark UNREM if compiled, > 9 LOCals = crash !
2255   CLS : CLS #0
2260   INPUT'Enter drive name:';d$
2265   OPEN_NEW #3,d$&'TMP_dir'
2270   DIR #3,d$ : CLOSE #3
2275   OPEN_IN #3,d$&'TMP_dir'
2280   INPUT #3,t$ : REMark read past medium name ...
2285   INPUT #3,t$ : REMark ... and capacity
2290   showing = 0
2295   WINDOW 512,256,0,0
2300   dw = DISPLAY_WIDTH_JM(#1)
2305   REPeat loop
2310     IF EOF(#3) : EXIT loop
2315     INPUT #3,t$
2320     IF t$ == 'TMP_dir' THEN NEXT loop
2325     IF FILE_TYPE(d$&t$) = 0 THEN 
2330       IF FILE_LENGTH(d$&t$) = 32768 THEN 
2335         OPEN_IN #4,d$&t$
2340         SELect ON showing
2345           =0 : sa = SCREEN_BASE(#1)
2350           =1 : sa = SCREEN_BASE(#1) + 64
2355           =2 : sa = SCREEN_BASE(#1) + (128*dw)
2360           =3 : sa = SCREEN_BASE(#1) + (128*dw) + 64
2365         END SELect 
2370         ap = 0
2375         FOR a = 0 TO 127
2380           ABS_POSITION #4,ap
2385           POKE_STRING sa,FETCH_BYTES(#4,64)
2390           ap = ap + 128 : REMark one line further in file
2395           sa = sa + dw : REMark one line further down screen
2400         END FOR a
2405         CLOSE #4
2410         sm2 = showing MOD 2 : sd2 = showing DIV 2
2415         REMark box sections in red
2420         BLOCK 256,1,256*sm2,128*sd2,2
2425         BLOCK 2,126,256*sm2+254,128*sd2+1,2
2430         BLOCK 256,1,256*sm2,128*sd2+127,2
2435         BLOCK 2,126,256*sm2,128*sd2+1,2
2440         CURSOR (256*sm2)+2,(128*sd2)+1 : PRINT t$
2445         showing = showing + 1 : REMark next section
2450         IF showing = 4 THEN 
2455           REMark pause after each screenful
2460           BEEP 200,10
2465           CURSOR_ENABLE #0 : k$ = INKEY$(-1) : CURSOR_DISABLE #0
2470           IF k$ = CHR$(27) THEN EXIT loop
2475           CLS : showing = 0
2480         END IF 
2485       END IF 
2490     END IF 
2495   END REPeat loop
2500   CLOSE #3 : DELETE d$&'TMP_dir' : PAUSE 100
2505   IF CHECK('wtv') THEN 
2510     WTV 4
2515   ELSE 
2520     WINDOW 448,200,32,16 : CLS : CLS #0
2525   END IF 
2530   PRINT #0,'PROGRAM FINISHED.'
2535 END DEFine QUARTER_SCREENS2
2540 :
2545 DEFine PROCedure MAKE_DIRECTORY
2550   LOCal d$, t$, l2_ok
2555   INPUT'Enter drive names :';d$
2560   IF d$(LEN(d$)) <> '_' THEN d$ = d$ & '_': END IF 
2565   PRINT 'Please wait, checking ...'
2570   DELETE d$ & CHR$(0) & CHR$(0)
2575   OPEN_NEW #3,d$ & CHR$(0) & CHR$(0)
2580   l2_ok = LEVEL2(#3)
2585   CLOSE #3
2590   DELETE d$ & CHR$(0) & CHR$(0)
2595   IF l2_ok
2600     INPUT 'Enter directory name please : ';t$
2605     MAKE_DIR d$ & t$
2610   ELSE 
2615     PRINT'Sorry, no level 2 drivers!'
2620   END IF 
2625 END DEFine MAKE_DIRECTORY
2630 :
2635 DEFine PROCedure SET_MODE (no)
2640   IF SCREEN_MODE <> no THEN MODE no
2645 END DEFine SET_MODE
2650 :
2655 DEFine PROCedure AUTO_REPEAT
2660   LOCal delay, period
2665   CLS : PRINT 'Delay is ';PEEK_W(SYSTEM_VARIABLES+140)
2670   PRINT'Period is ';PEEK_W(SYSTEM_VARIABLES+142)
2675   INPUT'New delay ? ';delay
2680   INPUT'New period ? ';period
2685   POKE_W SYSTEM_VARIABLES + 140,delay
2690   POKE_W SYSTEM_VARIABLES + 142,period
2695 END DEFine AUTO_REPEAT
2700 :
2705 DEFine PROCedure SHOW_CAPS_LOCK
2710   LOCal loop, cps
2715   CLS #0 : PRINT #0,'Press CAPS LOCK a few times (ESC to quit).'
2720   REPeat loop
2725     IF INKEY$ = CHR$(27) THEN EXIT loop
2730     cps = PEEK_W(SYSTEM_VARIABLES + 136)
2735     IF cps = 0 THEN 
2740       AT #0,1,0 : PRINT #0,'CAPS OFF'
2745     ELSE 
2750       AT #0,1,0 : PRINT #0,'CAPS ON '
2755     END IF 
2760   END REPeat loop
2765 END DEFine SHOW_CAPS_LOCK
2770 :
2775 DEFine FuNction LAST_KEY
2780   RETurn PEEK_W(SYSTEM_VARIABLES + 138)
2785 END DEFine LAST_KEY
2790 :
2795 DEFine PROCedure NET_STATION
2800   PRINT'This is network station number ';
2805   PRINT PEEK(SYSTEM_VARIABLES + 55)
2810 END DEFine NET_STATION
2815 :
2820 DEFine PROCedure BAUDRATE
2825   LOCal br
2830   REMark check current baudrate
2835   PRINT'Current baudrate is ';
2840   br = (PEEK(SYSTEM_VARIABLES + 160))&&7
2845   SELect ON br
2850     =0 : PRINT 19200
2855     =1 : PRINT 9600
2860     =2 : PRINT 4800
2865     =3 : PRINT 2400
2870     =4 : PRINT 1200
2875     =5 : PRINT 600
2880     =6 : PRINT 300
2885     =7 : PRINT 75
2890   END SELect 
2895 END DEFine BAUDRATE
2900 :
2905 DEFine PROCedure FIND_TEXT_IN_ROM
2910   LOCal t$, address
2915   CLS : INPUT'Enter text to search for in ROM:';t$
2920   address = SEARCH_I(0,48*1024,t$)
2925   IF address = 0
2930     PRINT'Not found'
2935   ELSE 
2940     PRINT'Found at address ';address
2945   END IF 
2950 END DEFine FIND_TEXT_IN_ROM
2955 :
2960 DEFine FuNction LINE_INPUT$ (channel,aty,atx,ending,maxlen,prompt$)
2965   LOCal t$,read_string,get_key
2970   REMark LOCal key
2975   :
2980   REMark UNREM the above line if you are compiling, > 9 Locals
2985   :
2990   IF maxlen = 0 THEN RETurn ''
2995   t$ = prompt$
3000   IF LEN(t$) > maxlen THEN t$ = t$(1 TO maxlen)
3005   AT #channel,aty,atx : PRINT #channel,prompt$;
3010   inx = LEN(t$)
3015   REPeat read_string
3020     AT #channel,aty,atx+inx
3025     CURSOR_ENABLE #channel
3030     key = CODE(INKEY$(#channel,-1))
3035     CURSOR_DISABLE #channel
3040     SELect ON key
3045       =192 : REMark left
3050         inx = inx - (inx > 0)
3055       =200 : REMark right
3060         inx = inx + (inx<LEN(t$))
3065       =208,216,10,27 : REMark end input
3070         ending = key : EXIT read_string
3075       =193 : REMark ALT left to end of line
3080         inx = 0
3085       =201 : REMark ALT right to end of line
3090         inx = LEN(t$)
3095       =195,203 : REMark CTRL ALT left/right, delete line
3100         AT #channel,aty,atx : PRINT #channel, FILL$(' ',LEN(t$));
3105         t$ = '' : inx = 0
3110       =32 TO 191 : REMark add character
3115         IF inx = 0 THEN 
3120           t$ = CHR$(key) & t$ : REMark add to front
3125         ELSE 
3130           IF inx = LEN(t$) THEN 
3135             t$ = t$ & CHR$(key) : REMark add to back end
3140           ELSE 
3145             t$ = t$(1 TO inx)&CHR$(key)&t$(inx+1 TO LEN(t$))
3150           END IF 
3155         END IF 
3160         IF LEN(t$) > maxlen THEN t$ = t$(1 TO maxlen)
3165         inx = inx + 1 : IF inx > LEN(t$) THEN inx = LEN(t$)
3170         AT #channel,aty,atx : PRINT #channel,t$;
3175       =194 : REMark CTRL LEFT, delete a character
3180         IF inx > 0 AND LEN(t$) > 0 THEN 
3185           IF inx = 1 THEN 
3190             inx = 0
3195             IF LEN(t$) = 1 THEN t$ = '' : AT #channel,aty,atx : PRINT #channel,t$ & ' '; : NEXT read_string
3200           END IF 
3205           IF inx = LEN(t$) THEN 
3210             t$ = t$(1 TO LEN(t$)-1) : inx =inx - 1
3215             AT #channel,aty,atx : PRINT #channel,t$&' ';
3220             NEXT read_string
3225           END IF 
3230           t$ = t$(1 TO inx-1)&t$(inx+1 TO LEN(t$))
3235           inx = inx - 1
3240           AT #channel,aty,atx : PRINT #channel,t$&' ';
3245         END IF 
3250       =202 : REMark CTRL RIGHT, delete a character
3255         IF LEN(t$) > 0 AND inx < LEN(t$) THEN 
3260           IF LEN(t$)=1 THEN 
3265             IF inx = 0 : t$ = ''
3270           ELSE 
3275             IF inx = 0 THEN 
3280               t$ = t$(2 TO LEN(t$))
3285             ELSE 
3290               IF inx = LEN(t$)-1 THEN 
3295                 t$ = t$(1 TO LEN(t$)-1)
3300               ELSE 
3305                 t$ = t$(1 TO inx)&t$(inx+2 TO LEN(t$))
3310               END IF 
3315             END IF 
3320           END IF 
3325           AT #channel,aty,atx : PRINT #channel,t$ & ' ';
3330         END IF 
3335     END SELect 
3340   END REPeat read_string
3345   RETurn t$
3350 END DEFine LINE_INPUT$
3355 :
3360 DEFine FuNction FETCH_BYTES_JM$(channel,bytes)
3365   LOCal version$,fetches,other,a,s$
3370   version$ = VER$ : REMark check QL ROM version
3375   IF version$ = 'AH' OR version$ = 'JM' THEN 
3380     fetches = INT(bytes/128)
3385     other = bytes - 128*fetches
3390     s$ = '' : REMark build up string fetched
3395     FOR a = 1 TO fetches
3400       s$ = s$ & FETCH_BYTES(#channel,128)
3405     END FOR a
3410     IF other > 0 : s$ = s$ & FETCH_BYTES(#channel,other)
3420     RETurn s$
3425   ELSE 
3430     RETurn FETCH_BYTES(#channel,bytes)
3435   END IF 
3440 END DEFine FETCH_BYTES_JM$
3445 :
3450 DEFine FuNction GET_STRING_JM$(chnl)
3455   LOCal version$,length
3460   version$ = VER$ : REMark check QL ROM version
3465   IF version$ = 'AH' OR version$ = 'JM' THEN 
3470     length = GET_WORD(#chnl)
3475     RETurn FETCH_BYTES_JM$(#chnl,length)
3480   ELSE 
3485     RETurn GET_STRING(#chnl)
3490   END IF 
3495 END DEFine GET_STRING_JM$
3500 :
3505 DEFine PROCedure FIND_FILE (drv$,txt$)
3510   REMark look for txt$ in all files in given drive
3515   LOCal f$, a_file, buffer, length, loop, fp, byte
3520   REMark LOCal finds, finds_xy, faddr, start_pos, end_pos
3525   REMark LOCal found_pos, fetched$
3530   :
3535   REMark UNREM the above 2 lines if compiled, > 9 locals = crash !
3540   :
3545   WINDOW 448,112,32,16    : BORDER 1,255    : PAPER 0    : CLS
3550   WINDOW #2,448,42,32,128 : BORDER #2,1,255 : PAPER #2,0 : CLS #2
3555   WINDOW #0,448,42,32,170 : BORDER #0,1,255 : PAPER #0,0 : CLS #0
3560   INK #2,7  : INK #0,7 : INK 7
3565   AT #0,0,5 : PRINT #0,'Looking for:';txt$
3570   AT #0,1,5 : PRINT #0,'On drive   :';drv$
3575   OPEN_NEW #4,drv$&'TMP_dir'
3580   DIR #4,drv$ : CLOSE #4 : OPEN_IN #4,drv$ & 'TMP_dir'
3585   INPUT #4,f$,f$ : REMark medium name and capacity
3590   finds = 0 : REMark files found to contain txt$
3595   finds_xy = 0 : REMark where found files are listed in #1
3600   buffer = 2048 : REMark string length fetched at a time
3605   AT #0,2,5 : PRINT #0,'Looking in :';
3610   REPeat a_file
3615     :
3620     REMark to add a PRESS ESC TO QUIT feature, add this line
3625     REMark and arrange for cursor to be on if required
3630     REMark IF INKEY$ = CHR$(27) THEN EXIT a_file
3635     :
3640     IF EOF(#4) : EXIT a_file
3645     INPUT #4,f$
3650     IF f$ == 'TMP_dir' THEN NEXT a_file
3655     faddr = 0 : REMark start of file
3660     AT #0,2,17 : CLS #0,4 : INK #0,2 : PRINT #0,f$ : INK #0,7
3665     OPEN_IN #3,drv$ & f$
3670     length = FILE_LENGTH(#3)
3675     REPeat loop
3680       REMark fetch "buffer" bytes at a time if possible
3685       IF faddr >= length THEN EXIT loop
3690       ABS_POSITION #3,faddr
3695       IF (length - faddr) >= buffer THEN 
3700         fetched$ = FETCH_BYTES_JM$(#3,buffer)
3705       ELSE 
3710         REMark less than "buffer" bytes to fetch
3715         fetched$ = FETCH_BYTES_JM$(#3,length - faddr)
3720       END IF 
3725       fp = txt$ INSTR fetched$ : REMark search for text
3730       IF fp THEN 
3735         REMark found, report on screen
3740         finds = finds + 1
3745         IF finds = 1 THEN INK 4 : PRINT 'Found in ...' : INK 7
3750         AT (finds_xy MOD 10)+1,37*(finds_xy DIV 10)
3755         INK 4 : PRINT finds;'.'; : INK 7 : PRINT f$
3760         finds_xy = finds_xy + 1
3765         :
3770         REMark put a printout option here if you have a printer
3775         REMark OPEN#5,SER1:PRINT#5,finds;'.';f$:CLOSE #5
3780         :
3785         REMark display some text either side of text found
3790         CLS #2 : INK #2,4
3795         found_pos = faddr + fp - 1
3800         PRINT #2,'LAST FOUND IN ';
3805         INK #2,2 : PRINT #2,f$; : INK #2,4
3810         PRINT #2,', FILE POSITION:';found_pos
3815         INK #2,7
3820         :
3825         REMark try to show 1 line of text either side of where found
3830         start_pos = found_pos - 74
3835         IF start_pos < 0 THEN start_pos = 0 : REMark oops
3840         end_pos = start_pos + 73 + 74
3845         IF end_pos >= length THEN end_pos = length - 1 : REMark oops
3850         IF (end_pos - start_pos) < (73+74) THEN 
3855           REMark oops, too near end, try backing off beginning
3860           start_pos = end_pos - 73 - 74
3865           IF start_pos < 0 THEN start_pos = 0 : REMark oops
3870         END IF 
3875         :
3880         ABS_POSITION #3,start_pos
3885         FOR a = start_pos TO end_pos
3890           byte = GET_BYTE (#3)
3895           IF byte = 10 : byte = 32 : REMark translate LF to SPACE
3900           PRINT #2,CHR$(byte);
3905         END FOR a
3910         :
3915         REMark pause after screenful
3920         IF finds_xy = 20 THEN 
3925           AT #0,2,5 : CLS #0,3 : INK #0,2
3930           PRINT #0,'PRESS ANY KEY TO CONTINUE. ';
3935           CURSOR_ENABLE #0 : k$ = INKEY$(-1) : CURSOR_DISABLE #0
3940           AT 0,0 : CLS 2 : finds_xy = 0
3945           INK #0,7 : AT #0,2,5 : CLS #0,3 : PRINT #0,'Looking in :';
3950           IF k$ = CHR$(27) THEN EXIT a_file
3955         ELSE 
3960           PAUSE 100 : REMark viewing time instead
3965         END IF 
3970         :
3975         EXIT loop : REMark finished with this one,look for next file!
3980         :
3985       END IF 
3990       :
3995       REMark not yet found, continue search
4000       faddr = faddr + buffer - LEN(txt$) + 1
4005       :
4010     END REPeat loop
4015     CLOSE #3
4020     :
4025     REMark look for next file
4030     :
4035   END REPeat a_file
4040   :
4045   CLOSE #4
4050   DELETE drv$ & 'TMP_dir'
4055   :
4060   CLS #0
4065   PRINT #0,'Total number of files where string was found:';finds
4070   INK #0,2 : PRINT #0,'PROGRAM FINISHED.' : INK #0,7
4075   :
4080   REMark remember to rest the windows afterwards, e.g. add:-
4085   REMark IF CHECK('WTV') THEN PAUSE : WTV 4
4090 END DEFine FIND_FILE
4095 :
4100 DEFine FuNction YN$
4105   LOCal k$(2),get_yn
4110   CURSOR_ENABLE #0
4115   REPeat get_yn
4120     k$ = INKEY$(-1)
4125     IF k$ = 'Y' : k$ = 'y'
4130     IF k$ = 'N' : k$ = 'n'
4135     IF k$ == 'y' OR k$ = 'n' THEN EXIT get_yn
4140   END REPeat get_yn
4145   CURSOR_DISABLE #0
4150   PRINT #0,k$ : RETurn k$
4155 END DEFine YN$
4160 :
4165 DEFine FuNction DISPLAY_SIZES
4170   REMark try to check, what screen limits we can use
4175   REMark first we check for QVME
4180   LOCal s_size, ferr, size
4185   s_size=0: REMark assume native QDOS
4190   IF CHECK('FOPEN') THEN 
4195     REMark Toolkit 2 present, use FOPEN function
4200     REPeat size
4205       REMark first try highest resolution, QVME display
4210       ferr=FOPEN(#3,'con_800x300a0x0')
4215       IF ferr<>-4: CLOSE#3: s_size=1: EXIT size: REMark yes, we are
4220       :
4225       REMark if not, then check if extended mode 4...
4230       ferr=FOPEN(#3,'con_768x268a0x0')
4235       IF ferr<>-4: CLOSE#3: s_size=2: EXIT size: REMark yes, it is
4240       :
4245       REMark if not, check if Atari ST mono mode...
4250       ferr=FOPEN(#3,'con_640x400a0x0')
4255       IF ferr<>-4: CLOSE#3: s_size=3: EXIT size: REMark yes, it is
4260       :
4265       REMark Assume the worst (a standard QL)..
4270       EXIT size
4275       :
4280     END REPeat size
4285   ELSE 
4290     IF CHECK('Q_ERR_ON') THEN 
4295       REMark use QLiberator error trapping
4300       Q_ERR_ON 'OPEN'
4305       REPeat size
4310         REMark first try highest resolution, QVME display
4315         OPEN #3,'con_800x300a0x0' : ferr = Q_ERR
4320         IF ferr<>-4: CLOSE#3: s_size=1: EXIT size
4325         :
4330         REMark if not, then check if extended mode 4...
4335         OPEN #3,'con_768x268a0x0' : ferr = Q_ERR
4340         IF ferr<>-4: CLOSE#3: s_size=2: EXIT size
4345         :
4350         REMark if not, check if Atari ST mono mode...
4355         OPEN #3,'con_640x400a0x0'
4360         IF ferr<>-4: CLOSE#3: s_size=3: EXIT size
4365         :
4370         REMark Assume the worst (a standard QL)..
4375         EXIT size
4380         :
4385       END REPeat size
4390       Q_ERR_OFF 'OPEN'
4395     ELSE 
4400       PRINT'Unable to use routine' : s_size = -1
4405       REMark could add a rom version test,if not AH/JM use WHEN ERRor
4410       REMark as another form of error trap here for this routine
4415     END IF 
4420   END IF 
4425   RETurn s_size
4430 END DEFine DISPLAY_SIZES
4435 :
4440 DEFine PROCedure IS_POINTER_ENVIRONMENT
4445   IF QPTR(#1) = 1 THEN 
4450     PRINT'Pointer environment is present.'
4455   ELSE 
4460     PRINT'Pointer environment is not present'
4465   END IF 
4470 END DEFine IS_POINTER_ENVIRONMENT
4475 :
4480 DEFine PROCedure REPORT_ON_FONTS (channel)
4485   LOCal address, lowest, number, b
4490   REMark show details of channel's fonts
4495   CLS
4500   FOR a = 1,2
4505     address = WHERE_FONTS(#channel,a)
4510     lowest = PEEK(address)
4515     number = PEEK(address+1)
4520     PRINT '#';channel;' font '; a; ' at address ';address
4525     PRINT 'Lowest character code = ';lowest
4530     PRINT 'Number of characters  = ';number + 1
4535     REMark print all but default characters
4540     PRINT : REMark blank line
4545     FOR b = lowest+1 TO lowest+number : PRINT CHR$(b);
4550     PRINT \\\ : REMark 2 blank lines
4555   END FOR a
4560 END DEFine REPORT_ON_FONTS
4565 :
4570 DEFine PROCedure LIST_HEAP
4575   LOCal where, wading_through, blocklen, address
4580   REMark List Blocks in common heap if a MegaTK or DJTK block
4585   :
4590   PRINT 'Using RESERVE_HEAP to ensure some blocks allocated'\\
4595   addr = RESERVE_HEAP(6): addr = RESERVE_HEAP(100)
4600   PRINT "DJTOOLKIT COMMON HEAP ALLOCATIONS"
4605   PRINT "ADDRESS LENGTH"
4610   :
4615   where = PEEK_L(SYSTEM_VARIABLES + 4) : REMark first block
4620   REPeat wading_through
4625     blocklen  = PEEK_L(where) : REMark length of block
4630     :
4635     REMark is it a DJToolkit allocation? If so, show it
4640     REMark the -20 is to allow for 16 byte header + 4 byte identifier
4645     IF PEEK_STRING(where+16,4)='NDhp' THEN 
4650       PRINT where+20 TO 8;blocklen - 16
4655     END IF 
4660     :
4665     IF where + blocklen = PEEK_L(SYSTEM_VARIABLES + 12) THEN 
4670       REMark oops, reached the end of the area!
4675       EXIT wading_through
4680     END IF 
4685     :
4690     where = where + blocklen : REMark jump to next block
4695   END REPeat wading_through
4700   PRINT \\ 'Now call CLEAR_DJTK_HEAP to release reserved areas'
4705 END DEFine LIST_HEAP
4710 :
4715 DEFine PROCedure CLEAR_DJTK_HEAP
4720   LOCal where, no, blocklen, a, wading_through
4725   LOCal addrs(100) : REMark or as many as required
4730   where = PEEK_L(SYSTEM_VARIABLES+4)
4735   no = 0
4740   REPeat wading_through
4745     blocklen = PEEK_L(where)
4750     IF PEEK_STRING(where+16,4) = 'NDhp' THEN 
4755       addrs(no) = where + 20
4760       no = no + 1
4765     END IF 
4770     IF where+blocklen = PEEK_L(SYSTEM_VARIABLES+12) THEN 
4775       EXIT wading_through
4780     END IF 
4785     where = where + blocklen
4790   END REPeat wading_through
4795   IF no = 0 THEN 
4800     PRINT 'Nothing to release!':RETurn 
4805   ELSE 
4810     PRINT 'Releasing heap block(s) at ';
4815     FOR a = no-1 TO 0 STEP -1
4820       PRINT !addrs(a)!
4825       RELEASE_HEAP addrs(a)
4830     END FOR a
4835     PRINT\'Finished.'
4840   END IF 
4845 END DEFine CLEAR_DJTK_HEAP
4850 :
4855 DEFine FuNction DISPLAY_WIDTH_JM(channel)
4860   LOCal v$
4865   v$ = VER$
4870   IF v$ = 'AH' OR v$ = 'JM' THEN 
4875     RETurn 128 : REMark the 'fixed' screen on these machines
4880   ELSE 
4885     RETurn DISPLAY_WIDTH(#channel)
4890   END IF 
4895 END DEFine DISPLAY_WIDTH_JM
4900 :
4905 DEFine FuNction ERROR_MESSAGE$ (err_code)
4910   LOCal what_happened, m$(30)
4915   what_happened = err_code
4920   SELect ON what_happened
4925     = 0 : m$ = ''
4930     =-1 : m$ = 'Not complete.'
4935     =-2 : m$ = 'Invalid job.'
4940     =-3 : m$ = 'Out of memory.'
4945     =-4 : m$ = 'Out of range.'
4950     =-5 : m$ = 'Buffer full.'
4955     =-6 : m$ = 'Channel not open.'
4960     =-7 : m$ = 'Not found.'
4965     =-8 : m$ = 'Already exists.'
4970     =-9 : m$ = 'In use.'
4975     =-10: m$ = 'End of file.'
4980     =-11: m$ = 'Drive full.'
4985     =-12: m$ = 'Bad name.'
4990     =-13: m$ = 'Transmission error.'
4995     =-14: m$ = 'Format failed.'
5000     =-15: m$ = 'Bad parameter.'
5005     =-16: m$ = 'Bad or changed medium.'
5010     =-17: m$ = 'Error in expression.'
5015     =-18: m$ = 'Overflow.'
5020     =-19: m$ = 'Not yet implemented.'
5025     =-20: m$ = 'Read only.'
5030     =-21: m$ = 'Bad line.'
5035     =-22: m$ = 'At line '
5040     =-23: m$ = ' sectors '
5045     =-24: m$ = 'F1...Monitor'&CHR$(10)&'F2...TV'
5050     =-25: m$ = CHR$(127) & ' 1983 Sinclair Research.'
5055     =-26: m$ = 'During WHEN processing.'
5060     =-27: m$ = 'PROC/FN cleared.'
5065   END SELect 
5070   RETurn m$
5075 END DEFine ERROR_MESSAGE$
5080 :
5085 DEFine PROCedure LARGE_TEXT(chnl,y,x,txt$)
5090   LOCal lc, nc, a, b , byte
5095   REMark LOCal font_addr, bit, cb
5100   :
5105   REMark UNREM the above line if compiling
5110   :
5115   font_addr = WHERE_FONTS(#chnl,1)
5120   lc = PEEK(font_addr)
5125   nc = PEEK(font_addr+1)
5130   FOR a = 1 TO LEN(txt$)
5135     cb = font_addr + 2 + 9*(CODE(txt$(a))-lc)
5140     FOR b = 0 TO 8
5145       byte = PEEK(cb+b)
5150       AT #chnl,y+b,x+(6*(a-1))
5155       FOR bit = 128,64,32,16,8,4
5160         IF byte && bit THEN 
5165           PRINT #chnl,txt$(a);
5170         ELSE 
5175           PRINT #chnl,' ';
5180         END IF 
5185       END FOR bit
5190     END FOR b
5195   END FOR a
5200 END DEFine LARGE_TEXT
5205 :
5210 DEFine PROCedure LOAD_A_FONT (chnl,f$)
5215   LOCal fl, fb
5220   fl = FILE_LENGTH(f$)
5225   IF fl < 0 THEN 
5230     PRINT #0,ERROR_MESSAGE$(fl)
5235     RETurn 
5240   END IF 
5245   fb = RESERVE_HEAP(fl)
5250   IF fb < 0 THEN 
5255     PRINT #0,ERROR_MESSAGE$(fb)
5260     RETurn 
5265   END IF 
5270   LBYTES f$,fb
5275   USE_FONT #chnl,fb,0 : REMark use as font 1 only here
5280   PRINT #chnl,'AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz'
5285   PRINT #chnl,'1234567890'
5290   USE_FONT #chnl,0,0 : REMark reset to ROM font
5295   RELEASE_HEAP fb
5300 END DEFine LOAD_A_FONT
5305 :
5310 DEFine PROCedure NARROW_TEXT
5315   LOCal d$, fl, fb, k$(1)
5320   IF SCREEN_MODE <> 4 : MODE 4
5325   WINDOW #0,512,200,0,16 : CLS #0
5330   INPUT #0,TO 10;"'NARROW_FNT' is on which drive ? ";d$
5335   fl = FILE_LENGTH(d$ & 'NARROW_FNT')
5340   IF fl < 0 THEN 
5345     WINDOW #0,448,40,32,216
5350     PRINT ERROR_MESSAGE$(fl)
5355     RETurn 
5360   END IF 
5365   fb = RESERVE_HEAP(fl)
5370   IF fb < 0 THEN 
5375     WINDOW #0,448,40,32,216
5380     PRINT ERROR_MESSAGE$(fl)
5385     RETurn 
5390   END IF 
5395   LBYTES d$ & 'NARROW_FNT',fb
5400   USE_FONT #0,fb,0
5405   SET_XINC #0,4
5410   SET_YINC #0,8
5415   CLS #0
5420   PRINT #0,TO 35;'NARROW FONT TYPEWRITER - TYPE AWAY TO SEE IT IN ACTION!'
5425   REPeat typing
5430     CURSOR_ENABLE #0
5435     k$ = INKEY$(#0,-1)
5440     CURSOR_DISABLE #0
5445     IF k$ = CHR$(27) THEN EXIT typing : ELSE PRINT #0,k$; : END IF 
5450   END REPeat typing
5455   PRINT #0, : REMark new line after printing
5460   USE_FONT #0,0,0 : SET_XINC #0,6 : SET_YINC #0,10
5465   RELEASE_HEAP fb
5470   WINDOW #0,448,40,32,216
5475 END DEFine NARROW_TEXT
5480 :
5485 DEFine PROCedure FASTCOPY (fd$,td$)
5490   LOCal fl(1), ft%(1), fa(1), f1, f2, fnm$(1,36), max%
5495   REMark LOCal base, copy_this%, m$, c$, find_end, entries%
5500   REMark LOCal a, copy_files, used, head_read_err, read_back
5505   REMark LOCal total_req, fm
5510   :
5515   REMark UNREM above 3 lines if compiled, >9 locals = crash !
5520   :
5525   REMark Quick copier for whole disk or cartridge
5530   REMark fd$ is from disk or cartridge
5535   REMark td$ is destination disk/cartridge
5540   CLS : CLS #0
5545   max% = 100 : REMark maximum number of files to copy
5550   DIM fnm$(max%,36)
5555   DIM fl(max%)  : REMark file length
5560   DIM ft%(max%) : REMark file type
5565   DIM fa(max%)  : REMark address loaded at
5570   DELETE(td$&'TMP_dir') : REMark in case one already exists
5575   OPEN_NEW #3,td$ & 'TMP_dir'
5580   DIR #3,fd$ : CLOSE #3
5585   OPEN_IN #3,td$&'TMP_DIR'
5590   INPUT#3,m$,c$ : REMark medium name and capacity
5595   entries% = 0
5600   REPeat read_back
5605     IF EOF(#3) : EXIT read_back
5610     INPUT #3,fnm$(entries%)
5615     OPEN_IN #4,fd$&fnm$(entries%)
5620     ft%(entries%) = FILE_TYPE(#4)
5625     IF ft%(entries%) <> 255 THEN 
5630       REMark get file length
5635       fl(entries%) = FILE_LENGTH(#4)
5640       REMark get file type
5645       ft%(entries%) = FILE_TYPE(#4)
5650       entries% = entries% + 1
5655       IF entries% > max% THEN EXIT read_back
5660     END IF 
5665     CLOSE #4
5670   END REPeat read_back
5675   CLOSE #3
5680   DELETE td$&'TMP_DIR'
5685   IF entries% = 0 THEN RETurn 
5690   REMark count up how much memory is required
5695   total_req = 0
5700   FOR a = 0 TO entries% - 1
5705     total_req = total_req + fl(a)
5710     REMark space must be even length to avoid LBYTES problems
5715     IF fl(a) <> 2*(INT(fl(a)/2)) : total_req = total_req + 1
5720   END FOR a
5725   fm = BYTES_FREE * .75 : REMark use 3/4 of free memory
5730   IF total_req < fm THEN fm = total_req
5735   base = RESERVE_HEAP(fm)
5740   IF base <= 0 THEN PRINT'Out of memory.' : RETurn 
5745   PRINT entries%;' files to copy.'
5750   REMark start to copy files
5755   f1 = 0  : REMark first file to copy
5760   REPeat copy_files
5765     IF f1 >= entries% THEN EXIT copy_files
5770     used = 0 : REMark heap memory used for this batch
5775     addr = base : REMark address at which to load next one
5780     REMark check in case first file is too long
5785     IF (64 + fl(f1)) > fm THEN 
5790       REMark use COPY to copy in the normal way if too big
5795       PRINT'COPYing ';fnm$(f1)
5800       COPY fd$ & fnm$(f1) TO td$ & fnm$(f1)
5805       f1 = f1 + 1
5810       NEXT copy_files
5815     END IF 
5820     used = 64 : REMark room for header
5825     addr = base + used : REMark where to load next file
5830     REMark read as many as possible in one go
5835     REMark f1 points to first file to copy
5840     f2 = f1 : REMark running pointer this batch
5845     PRINT
5850     REPeat find_end
5855       PRINT'Loading ';fnm$(f2)
5860       LBYTES fd$&fnm$(f2),addr
5865       fa(f2) = addr : REMark where loaded
5870       used = used + fl(f2)
5875       IF fl(f2) <> 2*(INT(fl(f2)/2)) THEN used = used + 1
5880       addr = base + used
5885       f2 = f2 + 1 : REMark point to next one
5890       IF f2 >= entries% THEN EXIT find_end : REMark all done
5895       REMark is there room for next file?
5900       IF (used + fl(f2)) > fm THEN EXIT find_end
5905     END REPeat find_end
5910     REMark f2 now points to first from next batch
5915     PRINT
5920     FOR a = f1 TO f2 - 1
5925       IF FILE_LENGTH(td$&fnm$(a))>=0 THEN 
5930         REMark query overwrite
5935         PRINT td$&fnm$(a)!'already'!'exists.'!'Delete Y/N ?';
5940         IF INKEY$(-1) == 'y' THEN 
5945           PRINT'y' : DELETE td$&fnm$(a) : copy_this% = 1
5950         ELSE 
5955           PRINT'n' : copy_this% = 0 : REMark skip this one
5960         END IF 
5965       ELSE 
5970         copy_this% = 1 : REMark did not already exist
5975       END IF 
5980       IF copy_this% = 1 THEN 
5985         PRINT'Saving ';fnm$(a)
5990         SBYTES td$&fnm$(a),fa(a),fl(a)
5995         REMark set file type by copying it from source
6000         OPEN_IN #4,fd$&fnm$(a)
6005         head_read_err = READ_HEADER (#4,base)
6010         CLOSE #4
6015         REMark insert it in destination file header
6020         OPEN #4,td$&fnm$(a)
6025         head_read_err = SET_HEADER (#4,base)
6030         CLOSE #4
6035       END IF 
6040     END FOR a
6045     IF f2 >= entries% THEN EXIT copy_files : REMark all done
6050     f1 = f2 : REMark start of next batch
6055   END REPeat copy_files
6060   RELEASE_HEAP base
6065 END DEFine FASTCOPY
6070 :
6075 DEFine PROCedure BACKUP_BY_DATE (fd$,td$)
6080   LOCal base, read_and_copy, f$, fer, updt, bkdt
6085   REMark backup files which have been changed since the last backup
6090   IF CHECK('SET_FBKDT') = 0 THEN 
6095     BEEP 2000,50
6100     PRINT 'Your system does not have the "SET_FBKDT"'
6105     PRINT 'command,so you may not use this routine !'
6110     RETurn 
6115   END IF 
6120   DELETE td$ & 'TMP_dir'
6125   OPEN_NEW #3,td$ & 'TMP_dir'
6130   DIR #3,fd$ : CLOSE #3
6135   OPEN_IN #3,td$ & 'TMP_dir'
6140   INPUT #3,f$ : REMark medium name
6145   INPUT #3,f$ : REMark medium capacity
6150   base = RESERVE_HEAP (64) : REMark for headers
6155   IF base < 0 THEN 
6160     REMark oops, hide the evidence
6165     CLOSE #3 : DELETE td$ & 'TMP_dir'
6170     PRINT ERROR_MESSAGE$(base)
6175     RETurn 
6180   END IF 
6185   REPeat read_and_copy
6190     IF EOF(#3) : EXIT read_and_copy
6195     INPUT #3,f$ : REMark filename from list
6200     OPEN_IN #4,fd$ & f$
6205     fer = READ_HEADER(#4,base)
6210     CLOSE #4
6215     updt = PEEK_L(base + 52)
6220     bkup = PEEK_L(base + 60)
6225     PRINT \f$\'Last updated ';DATE$(updt)\'Last backup ';DATE$(bkup)
6230     IF updt > bkup THEN 
6235       DELETE td$ & f$
6240       COPY fd$ & f$ TO td$ & f$
6245       PRINT'(file copied)'
6250       REMark alter backup date in file header on source
6255       REMark to current date (i.e. now, see Gold Card manual)
6260       SET_FBKDT \ fd$&f$
6265     ELSE 
6270       PRINT'(file not copied)'
6275     END IF 
6280   END REPeat read_and_copy
6285   CLOSE #3 : DELETE td$ & 'TMP_dir'
6290   RELEASE_HEAP base
6295 END DEFine BACKUP_BY_DATE
6300 :
6305 DEFine PROCedure CLEAR_BACKUP_DATES (fd$)
6310   LOCal f$
6315   REMark backup files which have been changed since the last backup
6320   IF CHECK('SET_FBKDT') = 0 THEN 
6325     BEEP 2000,50
6330     PRINT 'Your system does not have the "SET_FBKDT"'
6335     PRINT 'command,so you may not use this routine !'
6340     RETurn 
6345   END IF 
6350   DELETE fd$ & 'TMP_dir'
6355   OPEN_NEW #3,fd$ & 'TMP_dir'
6360   DIR #3,fd$ : CLOSE #3
6365   OPEN_IN #3,fd$ & 'TMP_dir'
6370   INPUT #3,f$ : REMark medium name
6375   INPUT #3,f$ : REMark medium capacity
6380   REMark we cannot use DATE of 0, since the Gold Card ignores it
6385   PRINT'Setting backup date to ';DATE$(1);' on:'
6390   REPeat read_and_reset
6395     IF EOF(#3) : EXIT read_and_reset
6400     INPUT #3,f$ : REMark filename from list
6405     IF f$ == 'TMP_dir' THEN NEXT read_and_reset
6410     SET_FBKDT\fd$&f$,1 : REMark back to earliest time
6415     PRINT f$ : REMark show files where backup date has been reset
6420   END REPeat read_and_reset
6425   CLOSE #3
6430   DELETE fd$ & 'TMP_dir'
6435 END DEFine CLEAR_BACKUP_DATES
6440 :
6445 DEFine PROCedure ALTER_DATASPACE
6450   LOCal base, loop, f$, ft, nv
6455   base = RESERVE_HEAP (64)
6460   IF base < 0 THEN 
6465     PRINT ERROR_MESSAGE$(base)
6470     RETurn 
6475   END IF 
6480   REPeat loop
6485     INPUT'Enter filename:';f$
6490     IF f$ = '' THEN EXIT loop
6495     ft = FILE_TYPE(f$)
6500     IF ft < 0 THEN 
6505       PRINT ERROR_MESSAGE$(ft) : NEXT loop
6510     END IF 
6515     IF ft <> 1 THEN 
6520       PRINT'Not an executable file!'
6525       NEXT loop
6530     END IF 
6535     PRINT'Current dataspace is:';FILE_DATASPACE(f$)
6540     INPUT'Enter new value:';nv
6545     OPEN #3,f$ : fer = READ_HEADER (#3,base)
6550     IF fer < 0 : CLOSE #3 : PRINT ERROR_MESSAGE$(fer) : NEXT loop
6555     POKE_L base + 6,nv
6560     fer = SET_HEADER(#3,base)
6565     IF fer < 0 : PRINT ERROR_MESSAGE$(fer)
6570     CLOSE #3
6575   END REPeat loop
6580   RELEASE_HEAP base
6585 END DEFine ALTER_DATASPACE
