7000 REMark DEMOS2_bas for DJToolkit, routines to demonstrate the use
7010 REMark of the new extensions in V1.14 and V1.15 of the Toolkit:
7020 REMark FILLMEM_B, FILLMEM_W, FILLMEM_L
7030 REMark PEEK_FLOAT, POKE_FLOAT, MAX_CON, MAX_DEVS
7040 REMark DJ_OPEN, DJ_OPEN_IN, DJ_OPEN_NEW, DJ_OPEN_OVER, DJ_OPEN_DIR
7050 :
7060 REMark these routines written by Dilwyn Jones, June 1994
7070 :
7080 DEFine PROCedure SCREEN_SIZES
7090   LOCal w%,h%,x%,y%,fer
7100   REMark how to work out maximum size of windows using iop.flim
7110   REMark using MAX_CON on primary channel returns screen size
7120   REMark secondaries return maximum sizes within outline where
7130   REMark pointer environment is used.
7140   w% = 512 : REMark width of standard QL screen
7150   h% = 256 : REMark height of standard QL screen
7160   x% = 0
7170   y% = 0
7180   :
7190   fer = MAX_CON(#0,w%,h%,x%,y%) : REMark primary for basic
7200   IF fer < 0 : PRINT #0,'Error ';fer : RETurn 
7210   PRINT'#0 : ';w%;',';h%;',';x%;',';y%
7220   :
7230   fer = MAX_CON(#1,w%,h%,x%,y%) : REMark primary for basic
7240   IF fer < 0 : PRINT #0,'Error ';fer : RETurn 
7250   PRINT'#1 : ';w%;',';h%;',';x%;',';y%
7260   :
7270   fer = MAX_CON(#2,w%,h%,x%,y%) : REMark primary for basic
7280   IF fer < 0 : PRINT #0,'Error ';fer : RETurn 
7290   PRINT'#2 : ';w%;',';h%;',';x%;',';y%
7300 END DEFine SCREEN_SIZES
7310 :
7320 DEFine PROCedure CLEAR_WHOLE_SCREEN
7330   LOCal w%,h%,x%,y%,fer,bytes
7340   w% = 512 : REMark width of standard QL screen
7350   h% = 256 : REMark height of standard QL screen
7360   x% = 0
7370   y% = 0
7380   fer = MAX_CON(#0,w%,h%,x%,y%)
7390   IF fer < 0 : PRINT #0,'Error ';fer : RETurn 
7400   bytes = DISPLAY_WIDTH(#0)*h%
7410   FILLMEM_W SCREEN_BASE(#0),bytes/2,0
7420 END DEFine CLEAR_WHOLE_SCREEN
7430 :
7440 DEFine PROCedure PEEK_FLOAT_DEMO
7450   LOCal base,a,loop,num
7460   REMark store 10 random numbers in an 'array' set up as a table
7470   REMark in memory and print the ones required
7480   base = RESERVE_HEAP(10*6) : REMark 10 6 byte values
7490   IF base <= 0 THEN 
7500     PRINT'OOPS, out of memory.'
7510     RETurn 
7520   END IF 
7530   REMark store 10 random numbers between 0 and 1 in the table
7540   FOR a = 0 TO 9
7550     POKE_FLOAT base+(6*a),RND
7560   END FOR a
7570   REMark now ask user which numbers from table to print
7580   REPeat loop
7590     INPUT'Which number shall I print (1 to 10, 0 to quit)?';num
7600     IF num = 0 THEN EXIT loop
7610     PRINT'Number ';num;' is ';PEEK_FLOAT(base+(6*(num-1)))
7620   END REPeat loop
7630   RELEASE_HEAP base
7640 END DEFine PEEK_FLOAT_DEMO
7650 :
7660 DEFine PROCedure L2_DIR (drive$,sub_directory$)
7670   LOCal loop,channel,d$,namelength,n$
7680   REMark ------------------------------------------------------
7690   REMark next routine lets users with level 2 directories
7700   REMark (Gold Card, hard disks, Ataris, etc)
7710   REMark list all files in all subdirectories of root specified
7720   REMark ------------------------------------------------------
7730   :
7740   REMark         Open directory channel to root specified
7750   REMark The fact that DJ_OPEN_DIR fins or creates a free channel
7760   REMark      number saves us a lot of work in this routine!
7770   :
7780   channel = DJ_OPEN_DIR(drive$&sub_directory$)
7790   IF channel < 0 : RETurn : REMark OOPS! Unable to open!
7800   :
7810   REPeat loop
7820     REMark if at end of list in this directory,unravel some recursion
7830     IF EOF(#channel) THEN EXIT loop
7840     d$ = FETCH_BYTES(#channel,64) : REMark one directory entry
7850     :
7860     namelength = CODE(d$(16))     : REMark LSB of name length
7870     IF namelength > 0 THEN 
7880       REMark null name usually indicates a deleted file
7890       n$ = d$(17 TO 16+namelength) : REMark get filename
7900       IF d$(6) = CHR$(255) THEN 
7910         REMark file type 255 is Miracle hard directory
7920         REMark remove following line for list only of filenames
7930         PRINT n$;' ->' : REMark usual directory name convention
7940         REMark call this routine again to list subdirectories
7950         L2_DIR drive$,n$
7960       ELSE 
7970         REMark this name is not a subdirectory, so list it as a
7980         REMark normal filename
7990         REMark remove next line for directory structure list only
8000         PRINT n$
8010       END IF 
8020     END IF 
8030   END REPeat loop
8040   :
8050   REMark finished with channel to that directory, close it
8060   CLOSE #channel
8070 END DEFine L2_DIR
8080 :
8090 DEFine PROCedure DIR_ARRAY (drive$, sub_directory$)
8100   REMark get all of filenames in specified directory into an array
8110   REMark make two passes, the first to find array dimensions required
8120   filenames%    = 0 : REMark number of entries to go into array
8130   directories%  = 0 : REMark number of directories
8140   longestfile%  = 0 : REMark longest filename
8150   longestdir%   = 0 : REMark longest directory name
8160   :
8170   DO_DIR drive$,sub_directory$,0 : REMark pass 0 to assess size
8180   IF (longestfile% && 1) = 1 THEN longestfile% = longestfile% + 1
8190   IF (longestdir% && 1)  = 1 THEN longestdir%  = longestdir% + 1
8200   :
8210   DIM filenames$(filenames%-1,longestfile%)
8220   DIM dirs$(directories%-1,longestdir%)
8230   filenames% = 0 : directories% = 0
8240   :
8250   DO_DIR drive$, sub_directory$, 1 : REMark store in arrays
8260   PRINT 'LIST OF DIRECTORIES'\\dirs$
8270   PRINT\\'LIST OF FILENAMES'\\filenames$
8280 END DEFine DIR_ARRAY
8290 :
8300 DEFine PROCedure DO_DIR (drive$,sub_directory$,pass)
8310   LOCal loop,channel,d$,namelength,n$
8320   channel = DJ_OPEN_DIR(drive$&sub_directory$)
8330   IF channel < 0 : RETurn : REMark OOPS! Unable to open!
8340   :
8350   REPeat loop
8360     IF EOF(#channel) THEN EXIT loop
8370     d$ = FETCH_BYTES(#channel,64)
8380     :
8390     namelength = CODE(d$(16))
8400     IF namelength > 0 THEN 
8410       REMark null name usually indicates a deleted file
8420       n$ = d$(17 TO 16+namelength) : REMark get filename
8430       IF d$(6) = CHR$(255) THEN 
8440         REMark file type 255 is Miracle hard directory
8450         REMark remove following line for list only of filenames
8460         IF pass = 0 THEN 
8470           IF LEN(n$) > longestdir% THEN longestdir% = LEN(n$)
8480         ELSE 
8490           dirs$(directories%) = n$
8500         END IF 
8510         directories% = directories% + 1
8520         DO_DIR drive$,n$,pass
8530       ELSE 
8540         REMark this name is not a subdirectory, so list it as a
8550         REMark normal filename
8560         REMark remove next line for directory structure list only
8570         IF pass = 0 THEN 
8580           IF LEN(n$) > longestfile% THEN longestfile% = LEN(n$)
8590         ELSE 
8600           filenames$(filenames%) = n$
8610         END IF 
8620         filenames% = filenames% + 1
8630       END IF 
8640     END IF 
8650   END REPeat loop
8660   :
8670   CLOSE #channel
8680 END DEFine DO_DIR
8690 :
8700 DEFine PROCedure SAVE_BIG_SCREEN (filename$)
8710   LOCal w%,h%,x%,y%,fer,dw_bytes
8720   w% = 512 : h% = 256 : x% = 0 : y% = 0 : REMark standard QL defaults
8730   fer = MAX_CON(#0,w%,h%,x%,y%)
8740   IF fer < 0 : PRINT #0,'Error ';fer : RETurn 
8750   dw_bytes = DISPLAY_WIDTH(#0)
8760   REMark add error trapping if required
8770   SBYTES filename$,SCREEN_BASE(#0),dw_bytes*h%
8780 END DEFine SAVE_BIG_SCREEN
8790 :
8800 DEFine FuNction STORE_BIG_SCREEN
8810   REMark returns address of where in memory copy of screen is stored
8820   LOCal w%,h%,x%,y%,fer,dw_bytes,store
8830   w% = 512 : h% = 256 : x% = 0 : y% = 0
8840   fer = MAX_CON(#0,w%,h%,x%,y%)
8850   IF fer < 0 : RETurn fer : REMark return error code
8860   dw_bytes = DISPLAY_WIDTH(#0)
8870   store = RESERVE_HEAP(dw_bytes*h%)
8880   REMark careful in case RESERVE_HEAP was not successful!
8890   IF store > 0 THEN MOVE_MEM SCREEN_BASE(#0) TO store, dw_bytes * h%
8900   RETurn store
8910 END DEFine STORE_BIG_SCREEN
8920 :
8930 DEFine PROCedure RESTORE_BIG_SCREEN (from)
8940   REMark "from" is the address returned by "STORE_BIG_SCREEN"
8950   LOCal w%,h%,x%,y%,fer,dw_bytes,a
8960   w% = 512 : h% = 256 : x% = 0 : y% = 0
8970   fer = MAX_CON (#0,w%,h%,x%,y%)
8980   IF fer < 0 : PRINT #0,'Error ';fer : RETurn 
8990   dw_bytes = DISPLAY_WIDTH(#0)
9000   MOVE_MEM from TO SCREEN_BASE(#0), h% * dw_bytes
9010   RELEASE_HEAP from : from = 0
9020 END DEFine RESTORE_BIG_SCREEN
9030 :
9040 DEFine PROCedure SAVE_PTR_SCREEN (filename$)
9050   LOCal w%,h%,x%,y%,chan,dw_bytes,chan,address,a
9060   REMark save whole screen in pointer environment save format
9070   w% = 512 : h% = 256 : x% = 0 : y% = 0
9080   chan = MAX_CON(#0,w%,h%,x%,y%)
9090   IF chan < 0 : PRINT #0,'Error ';fer : RETurn 
9100   dw_bytes = DISPLAY_WIDTH(#0)
9110   chan = DJ_OPEN_NEW(filename$)
9120   IF chan = -8 THEN 
9130     PRINT #0,'Already exists. Delete Y/N ? ';
9140     IF INKEY$(-1) == 'y' THEN 
9150       PRINT #0,'Y'
9160       chan = DJ_OPEN_OVER(filename$)
9170     ELSE 
9180       REMark abandon without deleting
9190       PRINT #0,'N'
9200       RETurn 
9210     END IF 
9220   END IF 
9230   IF chan < 0 : BEEP 5000,50 : RETurn : REMark oops, error occurred
9240   :
9250   REMark build up file preamble (10 bytes)
9260   PRINT #chan,CHR$(74)&CHR$(252); : REMark $4AFC identifier
9270   PUT_WORD #chan,w%          : REMark picture width in pixels
9280   PUT_WORD #chan,h%          : REMark picture height in pixels
9290   PUT_WORD #chan,dw_bytes    : REMark line increment in bytes
9300   PUT_BYTE #chan,SCREEN_MODE : REMark screen mode number
9310   PUT_BYTE #chan,0           : REMark spare unused byte required
9320   :
9330   REMark save picture itself
9340   address = SCREEN_BASE (#0)
9350   FOR a = 1 TO h%
9360     PRINT #chan,PEEK_STRING(address, dw_bytes);
9370     address = address + dw_bytes
9380   END FOR a
9390   :
9400   CLOSE #chan : REMark tidy up!
9410 END DEFine SAVE_PTR_SCREEN
9420 :
9430 DEFine PROCedure LOAD_PTR_SCREEN (filename$)
9440   REMark load a saved image to the screen, can be smaller than screen
9450   LOCal w%,h%,x%,y%,chan,pw%,ph%,a,to_addr
9460   w% = 512 : h% = 256 : x% = 0 : y% = 0
9470   chan = MAX_CON(#0,w%,h%,x%,y%)
9480   dw_bytes = DISPLAY_WIDTH(#0)
9490   chan = DJ_OPEN_IN (filename$)
9500   IF chan < 0 : BEEP 5000,50 : RETurn 
9510   REMark file type we require is at least 10 bytes long
9520   IF FILE_LENGTH(#chan) < 10 : CLOSE #chan : BEEP 5000,50 : RETurn 
9530   IF FETCH_BYTES(#chan,2) <> (CHR$(74)&CHR$(252)) THEN 
9540     REMark not the file type we require (first two bytes wrong)
9550     BEEP 5000,50 : CLOSE #chan : RETurn 
9560   END IF 
9570   pw% = GET_WORD(#chan) : REMark picture width (pixels)
9580   ph% = GET_WORD(#chan) : REMark picture height (pixels)
9590   x%  = GET_WORD(#chan) : REMark line increment, bytes
9600   y%  = GET_BYTE(#chan) : REMark mode number
9610   MOVE_POSITION #chan,1 : REMark skip spare byte
9620   :
9630   REMark check file details against screen
9640   REMark is new picture too wide?
9650   IF x% <> dw_bytes : CLOSE #chan : BEEP 5000,50 : RETurn 
9660   REMark is it too wide or tall?
9670   IF pw% > w% OR ph% > h% THEN CLOSE #chan : BEEP 5000,50 : RETurn 
9680   REMark is screen in correct mode?
9690   IF y% <> SCREEN_MODE THEN 
9700     MODE y%
9710     IF SCREEN_MODE <> y% THEN 
9720       REMark that was for the benefit of ST QL users. Failed to
9730       REMark change mode so give up gracefully!
9740       CLOSE #chan : BEEP 5000,50 : RETurn 
9750     END IF 
9760   END IF 
9770   REMark fetch to screen, one line at a time
9780   to_addr = SCREEN_BASE (#0)
9790   FOR a = 1 TO h%
9800     REMark WARNING FOR VERSION AH/JM ROM USERS!
9810     REMark use FETCH_BYTES_JM$ routine from DEMOS1_bas
9820     REMark in line below if fetching pictures more than 128
9830     REMark bytes wide (due to buffer overflow error risk) !
9840     POKE_STRING to_addr, FETCH_BYTES(#chan,x%)
9850     to_addr = to_addr + dw_bytes
9860   END FOR a
9870   CLOSE #chan
9880 END DEFine LOAD_PTR_SCREEN
9890 :
9900 DEFine FuNction OPEN_OVER_QUERY (filename$)
9910   LOCal chan
9920   chan = DJ_OPEN_NEW (filename$)
9930   IF chan = -8 THEN 
9940     REMark error code already exists
9950     PRINT #0,'Filename already exists. Delete Y/N ? ';
9960     IF INKEY$(-1) == 'y' THEN 
9970       chan = DJ_OPEN_OVER (filename$)
9980     END IF 
9990   END IF 
10000   RETurn chan
10010 END DEFine OPEN_OVER_QUERY
10020 :
10030 DEFine FuNction TK2_DATA$
10040   LOCal address
10050   address = PEEK_L (SYSTEM_VARIABLES + 176)
10060   IF address = 0 THEN 
10070     RETurn '' : REMark does not exist
10080   ELSE 
10090     REMark this is a pointer to the data default
10100     REMark the data default consists of name length word
10110     REMark plus the name itself
10120     RETurn PEEK_STRING(address+2,PEEK_W(address))
10130   END IF 
10140 END DEFine TK2_DATA$
10150 :
10160 DEFine FuNction TK2_PROG$
10170   LOCal address
10180   address = PEEK_L (SYSTEM_VARIABLES + 172)
10190   IF address = 0 THEN 
10200     RETurn '' : REMark does not exist
10210   ELSE 
10220     REMark this is a pointer to the prog default as above
10230     RETurn PEEK_STRING(address+2,PEEK_W(address))
10240   END IF 
10250 END DEFine TK2_PROG$
10260 :
10270 DEFine FuNction TK2_DEST$
10280   LOCal address
10290   address = PEEK_L (SYSTEM_VARIABLES + 180)
10300   IF address = 0 THEN 
10310     RETurn ''
10320   ELSE 
10330     REMark this is a pointer to the destination default
10340     RETurn PEEK_STRING(address+2,PEEK_W(address))
10350   END IF 
10360 END DEFine TK2_DEST$
10370 :
10380 DEFine FuNction OPEN_IN_TK2 (filename$)
10390   LOCal chan,temp$
10400   chan = DJ_OPEN (filename$)
10410   IF chan < 0 THEN 
10420     temp$ = TK2_DATA$ & filename$
10430     chan = DJ_OPEN_IN (temp$)
10440     REMark you may wish to add this line, to change "filename$":
10450     REMark IF chan >= 0 THEN filename$ = temp$
10460   END IF 
10470   RETurn chan
10480 END DEFine OPEN_IN_TK2
10490 :
10500 DEFine PROCedure FILE_BROWSER
10510   LOCal a,devices,key,program,st$
10520   devices = MAX_DEVS
10530   DIM array$(devices,36)
10540   addr = 0 : REMark will be modified each time dev_name is called
10550   FOR a = 1 TO devices
10560     array$(a) = DEV_NAME(addr)
10570   END FOR a
10580   WINDOW #0,448,40,32,216 : PAPER #0,0 : INK #0,7 : CLS #0
10590   WINDOW 448,200,32,16    : PAPER 2    : INK 7    : CLS
10600   PRINT #0,'DEVICES     :   '; : REMark list devices
10610   FOR a = 1 TO devices : PRINT #0,!array$(a)!
10620   PRINT#0,\'DRIVE NUMBER:   1   2   3   4   5   6   7   8'
10630   PRINT #0,'Press first letter of device name, or number, ESC to quit :';
10640   device_number = 1 : devnum = 1 : REMark usually starts blank
10650   st$ = array$(devnum)&device_number&'_'
10660   REPeat program
10670     key = CODE(INKEY$(-1))
10680     SELect ON key
10690       =27 : EXIT program : REMark ESC pressed
10700       =49 TO 56 : REMark number keys, add to device
10710         device_number = key - 48
10720         st$ = array$(devnum)&device_number&'_'
10730       =65 TO 90,97 TO 122
10740         REMark new device, which one starts with this letter
10750         FOR a = 1 TO devices
10760           IF CODE(array$(a))=key OR (CODE(array$(a))+32)=key THEN 
10770             devnum = a : st$ = array$(devnum) & device_number&'_'
10780             EXIT a
10790           END IF 
10800         NEXT a
10810           BEEP 5000,50 : REMark oops, not found
10820         END FOR a
10830       =REMAINDER : NEXT program
10840     END SELect 
10850     AT #0,2,59 : CLS #0,4 : PRINT #0,st$;
10860     CLS : L2_DIR st$,''
10870   END REPeat program
10880 END DEFine FILE_BROWSER
